// htmlfrm.cpp : implementation of the CHtmlFrame and CHtmlChildWnd class
//

#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHtmlFrame

IMPLEMENT_DYNAMIC(CHtmlFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CHtmlFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CHtmlFrame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHtmlFrame construction/destruction

CHtmlFrame::CHtmlFrame()
{
	// TODO: add member initialization code here
}

CHtmlFrame::~CHtmlFrame()
{
}


////////////////////////////////////////////////////////////////////////////
// overide CMDIFrameWnd::MDIGetActive in order to disable the CMDIChildWnd 
// checking, because HTML window is not a CMDIChildWnd.
CHtmlChildWnd* CHtmlFrame::MDIGetActive(BOOL* pbMaximized /*= NULL*/) const
{
	LRESULT l;
	l = ::SendMessage(m_hWndMDIClient, WM_MDIGETACTIVE, 0, 0);
	CHtmlChildWnd* pWnd = (CHtmlChildWnd*)CWnd::FromHandle((HWND)LOWORD(l));
	/*ASSERT(pWnd == NULL || pWnd->IsKindOf(RUNTIME_CLASS(CHtmlChildWnd)));

	// check for special pseudo-inactive state
	if (pWnd != NULL && pWnd->m_bPseudoInactive &&
		(pWnd->GetStyle() & WS_VISIBLE) == 0)
	{
		// Window is hidden, active, but m_bPseudoInactive -- return NULL
		pWnd = NULL;
	}*/
	
	if (pWnd && pWnd->IsKindOf(RUNTIME_CLASS(CHtmlChildWnd)))
	{
		// check for special pseudo-inactive state
		if (pWnd->m_bPseudoInactive &&
			(pWnd->GetStyle() & WS_VISIBLE) == 0)
		{
			// Window is hidden, active, but m_bPseudoInactive -- return NULL
			pWnd = NULL;
		}
	}

	if (pbMaximized != NULL)
		*pbMaximized = pWnd != NULL && HIWORD(l);

	return pWnd;
}

////////////////////////////////////////////////////////////////////////////
// override the following methods of CMDIFrameWnd because otherwise they try to
// call CMDIFrameWnd::MDIGetActive() directly rather than CHtmlFrame::MDIGetActive()
// even if we have a CHtmlFrame class here.
BOOL CHtmlFrame::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// send to MDI child first - will be re-sent through OnCmdMsg later
	CHtmlChildWnd* pActiveChild = MDIGetActive();
	if (pActiveChild != NULL && _AfxCallWndProc(pActiveChild,
	  pActiveChild->m_hWnd, WM_COMMAND, wParam, lParam) != 0)
		return TRUE; // handled by child

	if (CFrameWnd::OnCommand(wParam, lParam))
		return TRUE; // handled through normal mechanism (MDI child or frame)

	HWND hWndCtrl = (HWND)LOWORD(lParam);

	ASSERT(AFX_IDM_FIRST_MDICHILD == 0xFF00);
	if (hWndCtrl == NULL && (LOWORD(wParam) & 0xf000) == 0xf000)
	{
		// menu or accelerator within range of MDI children
		// default frame proc will handle it
		DefWindowProc(WM_COMMAND, wParam, lParam);
		return TRUE;
	}

	return FALSE;   // not handled
}

BOOL CHtmlFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra,
	AFX_CMDHANDLERINFO* pHandlerInfo)
{
	CHtmlChildWnd* pActiveChild = MDIGetActive();
	// pump through active child FIRST
	if (pActiveChild != NULL &&
	  pActiveChild->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// then pump through normal frame
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

#define HID_BASE_COMMAND    0x00010000UL	// ID and IDM
#define WM_COMMANDHELP      0x0365			// lResult = TRUE/FALSE, lParam = dwContext

LRESULT CHtmlFrame::OnCommandHelp(WPARAM wParam, LPARAM lParam)
{
	if (lParam == 0 && IsTracking())
		lParam = HID_BASE_COMMAND+m_nIDTracking;

	CHtmlChildWnd* pActiveChild = MDIGetActive();
	if (pActiveChild != NULL && _AfxCallWndProc(pActiveChild,
	  pActiveChild->m_hWnd, WM_COMMANDHELP, wParam, lParam) != 0)
	{
		// handled by child
		return TRUE;
	}

	if (CFrameWnd::OnCommandHelp(wParam, lParam))
	{
		// handled by our base
		return TRUE;
	}

	if (lParam != 0)
	{
		AfxGetApp()->WinHelp(lParam);
		return TRUE;
	}
	return FALSE;
}

BOOL CHtmlFrame::PreTranslateMessage(MSG* pMsg)
{
	// check for special cancel modes for ComboBoxes
	if (pMsg->message == WM_LBUTTONDOWN || pMsg->message == WM_NCLBUTTONDOWN)
		_AfxCancelModes(pMsg->hwnd);    // filter clicks

	/*// allow hook to consume message
	if (m_pNotifyHook != NULL && m_pNotifyHook->OnPreTranslateMessage(pMsg))
		return TRUE;
    */
	CHtmlChildWnd* pActiveChild = MDIGetActive();

	// current active child gets first crack at it
	if (pActiveChild != NULL &&
		pActiveChild->PreTranslateMessage(pMsg))
		return TRUE;

	if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
	{
		// translate accelerators for frame and any children
		if (m_hAccelTable != NULL &&
			::TranslateAccelerator(m_hWnd, m_hAccelTable, pMsg))
		{
			return TRUE;
		}

		// special processing for MDI accelerators last
		// and only if it is not in SDI mode (print preview)
		if (GetActiveView() == NULL)
		{
			if (pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN)
			{
				// the MDICLIENT window may translate it
				if (::TranslateMDISysAccel(m_hWndMDIClient, pMsg))
					return TRUE;
			}
		}
	}

	return FALSE;
}


CFrameWnd* CHtmlFrame::GetActiveFrame()
{
	CHtmlChildWnd* pActiveChild = this->MDIGetActive();
	if (pActiveChild == NULL || !pActiveChild->IsKindOf(RUNTIME_CLASS(CHtmlChildWnd)))
		return this;
	return pActiveChild;
}

void CHtmlFrame::OnUpdateFrameMenu(HMENU hMenuAlt)
{
	CHtmlChildWnd* pActiveWnd = MDIGetActive();
	if (pActiveWnd != NULL || !pActiveWnd->IsKindOf(RUNTIME_CLASS(CHtmlChildWnd)))
	{
		// let child update the menu bar
		pActiveWnd->OnUpdateFrameMenu(TRUE, pActiveWnd, hMenuAlt);
	}
	else
	{
		// no child active, so have to update it ourselves
		//  (we can't send it to a child window, since pActiveWnd is NULL)
		if (hMenuAlt == NULL)
			hMenuAlt = m_hMenuDefault;  // use default
		HMENU hMenuLast = NULL;
		WORD nVersion = LOWORD(::GetVersion());
		BOOL bWin31 = ((LOBYTE(nVersion) << 8) + HIBYTE(nVersion)) >= 0x030a;
		if (!bWin31)    // Windows 3.0 needs to remove the separator
			hMenuLast = GetWindowMenuPopup(::GetMenu(m_hWnd));
		::SendMessage(m_hWndMDIClient, WM_MDISETMENU, 0,
			MAKELONG(hMenuAlt, hMenuLast));
	}
}

void CHtmlFrame::OnUpdateFrameTitle(BOOL bAddToTitle)
{
	if ((GetStyle() & FWS_ADDTOTITLE) == 0)
		return;     // leave it alone!

	/*// allow hook to set the title (used for OLE 2.0 support)
	if (m_pNotifyHook != NULL && m_pNotifyHook->OnUpdateFrameTitle())
		return;
    */
	CHtmlChildWnd* pActiveChild;
	CDocument* pDocument = GetActiveDocument();
	if (bAddToTitle &&
	  (pActiveChild = MDIGetActive()) != NULL &&
	  (pActiveChild->GetStyle() & WS_MAXIMIZE) == 0 &&
	  (pDocument != NULL ||
	  pActiveChild->IsKindOf(RUNTIME_CLASS(CHtmlChildWnd)) &&
	  (pDocument = pActiveChild->GetActiveDocument()) != NULL))
		UpdateFrameTitleForDocument(pDocument->GetTitle());
	else
		UpdateFrameTitleForDocument(NULL);
}

void CHtmlFrame::OnUpdateMDIWindowCmd(CCmdUI* pCmdUI)
{
	ASSERT(m_hWndMDIClient != NULL);
	pCmdUI->Enable(MDIGetActive() != NULL);
}

void CHtmlFrame::OnWindowNew()
{
	CHtmlChildWnd* pActiveChild = MDIGetActive();
	CDocument* pDocument;
	if (pActiveChild == NULL ||
	  (pDocument = pActiveChild->GetActiveDocument()) == NULL)
	{
		TRACE0("Warning: No active document for WindowNew command\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		return;     // command failed
	}

	// otherwise we have a new frame !
	CDocTemplate* pTemplate = pDocument->GetDocTemplate();
	ASSERT_VALID(pTemplate);
	CFrameWnd* pFrame = pTemplate->CreateNewFrame(pDocument, pActiveChild);
	if (pFrame == NULL)
	{
		TRACE0("Warning: failed to create new frame\n");
		return;     // command failed
	}

	pTemplate->InitialUpdateFrame(pFrame, pDocument);
}


/////////////////////////////////////////////////////////////////////////////
// CHtmlChildWnd

IMPLEMENT_DYNCREATE(CHtmlChildWnd, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CHtmlChildWnd, CMDIChildWnd)
	//{{AFX_MSG_MAP(CHtmlChildWnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHtmlChildWnde construction/destruction

CHtmlChildWnd::CHtmlChildWnd()
{
	// TODO: add member initialization code here
}

CHtmlChildWnd::~CHtmlChildWnd()
{
}


BOOL CHtmlChildWnd::LoadFrame(UINT nIDResource, DWORD dwDefaultStyle,
		CWnd* pParentWnd, CCreateContext* pContext)
{
	// only do this once
	ASSERT(nIDResource != 0 && nIDResource < 0x8000);
	ASSERT(m_nIDHelp == 0 || m_nIDHelp == nIDResource);
	ASSERT(m_hMenuShared == NULL);      // only do once

	m_nIDHelp = nIDResource;    // ID for help context (+HID_BASE_RESOURCE)

	// parent must be MDI Frame (or NULL for default)
	ASSERT(pParentWnd == NULL || pParentWnd->IsKindOf(RUNTIME_CLASS(CHtmlFrame)));
	// will be a child of MDIClient
	ASSERT(!(dwDefaultStyle & WS_POPUP));
	dwDefaultStyle |= WS_CHILD;

	// if available - get MDI child menus from doc template
	ASSERT(m_hMenuShared == NULL);      // only do once
	CMultiDocTemplate* pTemplate;
	if (pContext != NULL &&
		(pTemplate = (CMultiDocTemplate*)pContext->m_pNewDocTemplate) != NULL)
	{
		ASSERT(pTemplate->IsKindOf(RUNTIME_CLASS(CMultiDocTemplate)));
		// get shared menu from doc template
		m_hMenuShared = pTemplate->m_hMenuShared;
		m_hAccelTable = pTemplate->m_hAccelTable;
	}
	else
	{
		TRACE0("Warning: no shared menu/acceltable for MDI Child window\n");
			// if this happens, programmer must load these manually
	}

	CString strFullString, strTitle;
	if (strFullString.LoadString(nIDResource))
		AfxExtractSubString(strTitle, strFullString, 0);    // first sub-string

	ASSERT(m_hWnd == NULL);
	if (!CHtmlChildWnd::Create(GetIconWndClass(dwDefaultStyle, nIDResource),
	  strTitle, dwDefaultStyle, rectDefault,
	  (CHtmlFrame *)pParentWnd, pContext))
		return FALSE;   // will self destruct on failure normally

	// it worked !
	return TRUE;
}

BOOL CHtmlChildWnd::Create(LPCSTR lpszClassName,
	LPCSTR lpszWindowName, DWORD dwStyle,
	const RECT& rect, CHtmlFrame *pParentWnd,
	CCreateContext* pContext)
{
	if (pParentWnd == NULL)
	{
		CWnd* pMainWnd = AfxGetApp()->m_pMainWnd;
		ASSERT(pMainWnd != NULL);
		ASSERT(pMainWnd->IsKindOf(RUNTIME_CLASS(CHtmlFrame)));
		pParentWnd = (CHtmlFrame *)pMainWnd;
	}

	// first copy into a CREATESTRUCT for PreCreate
	CREATESTRUCT cs;
	cs.dwExStyle = 0L;
	cs.lpszClass = lpszClassName;
	cs.lpszName = lpszWindowName;
	cs.style = dwStyle;
	cs.x = rect.left;
	cs.y = rect.top;
	cs.cx = rect.right - rect.left;
	cs.cy = rect.bottom - rect.top;
	cs.hwndParent = pParentWnd->m_hWnd;
	cs.hMenu = NULL;
	cs.hInstance = AfxGetInstanceHandle();
	cs.lpCreateParams = (LPVOID)pContext;

	if (!PreCreateWindow(cs))
	{
		PostNcDestroy();
		return FALSE;
	}
	ASSERT(cs.dwExStyle == 0);  // must be zero for MDI Children
	ASSERT(cs.hwndParent == pParentWnd->m_hWnd);    // must not change

	// now copy into a MDICREATESTRUCT for real create
	MDICREATESTRUCT mcs;
	mcs.szClass = cs.lpszClass;
	mcs.szTitle = cs.lpszName;
	mcs.hOwner = cs.hInstance;
	mcs.x = cs.x;
	mcs.y = cs.y;
	mcs.cx = cs.cx;
	mcs.cy = cs.cy;
	mcs.style = cs.style;
	mcs.lParam = (LONG)cs.lpCreateParams;

	// Win 30 requires we have an MDI Window menu before creation
	WORD nVersion = LOWORD(::GetVersion());
	BOOL bWin31 = ((LOBYTE(nVersion) << 8) + HIBYTE(nVersion)) >= 0x030a;
	if (!bWin31 && m_hMenuShared != NULL &&
	  ::GetMenu(pParentWnd->m_hWnd) == pParentWnd->m_hMenuDefault)
		::SendMessage(pParentWnd->m_hWndMDIClient, WM_MDISETMENU, 0,
			MAKELONG(NULL, pParentWnd->GetWindowMenuPopup(m_hMenuShared)));

	_AfxHookWindowCreate(this);
	HWND hWnd = (HWND)::SendMessage(pParentWnd->m_hWndMDIClient,
		WM_MDICREATE, 0, (LONG)(LPSTR)&mcs);
	if (!_AfxUnhookWindowCreate())
		PostNcDestroy();        // cleanup if MDICREATE fails too soon

	pParentWnd->MDIGetActive();

	if (hWnd == NULL)
		return FALSE;
	ASSERT(hWnd == m_hWnd);
	return TRUE;
}

void CHtmlChildWnd::ActivateFrame(int nCmdShow)
{
	BOOL bVisibleThen = (GetStyle() & WS_VISIBLE) != 0;

	CHtmlFrame* pFrameWnd = (CHtmlFrame *)GetMDIFrame();
	BOOL bMaximized;
	pFrameWnd->MDIGetActive(&bMaximized);
	if (nCmdShow == -1 && bMaximized)
		nCmdShow = SW_SHOWMAXIMIZED;    // maximize if previous frame was
	CFrameWnd::ActivateFrame(nCmdShow);

	// Note: Update the m_bPseudoInactive flag.  This is used to handle the
	//  last MDI child getting hidden.  Windows provides no way to deactivate
	//  an MDI child window.

	BOOL bVisibleNow = (GetStyle() & WS_VISIBLE) != 0;
	if (bVisibleNow == bVisibleThen)
		return;

	if (!bVisibleNow)
	{
		// get current active window according to Windows MDI
		LRESULT l;
		l = ::SendMessage(pFrameWnd->m_hWndMDIClient, WM_MDIGETACTIVE, 0, 0);
		HWND hWnd = (HWND)LOWORD(l);
		if (hWnd != m_hWnd)
		{
			// not active any more -- window must have been deactivated
			ASSERT(!m_bPseudoInactive);
			return;
		}

		// try next window
		ASSERT(hWnd != NULL);
		pFrameWnd->MDINext();

		// see if it has been deactivated now...
		l = ::SendMessage(pFrameWnd->m_hWndMDIClient, WM_MDIGETACTIVE, 0, 0);
		hWnd = (HWND)LOWORD(l);
		if (hWnd == m_hWnd)
		{
			// still active -- fake deactivate it
			ASSERT(hWnd != NULL);
			OnMDIActivate(FALSE, NULL, this);
			m_bPseudoInactive = TRUE;   // so MDIGetActive returns NULL
		}
	}
	else if (m_bPseudoInactive)
	{
		// if state transitioned from not visible to visible, but
		//  was pseudo deactivated -- send activate notify now
		OnMDIActivate(TRUE, this, NULL);
		ASSERT(!m_bPseudoInactive); // should get set in OnMDIActivate!
	}
}

