// mainfrm.cpp : implementation of the CMainFrame class
//
#include "stdafx.h"
#include <afxdlgs.h>        // MFC CFileDialog
#include "isdkdemo.h"

#include "mainfrm.h"
#include "rmtopen.h" 
#include "tc_html.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CHtmlFrame)

BEGIN_MESSAGE_MAP(CMainFrame, CHtmlFrame)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE() 
	ON_WM_PALETTECHANGED() 
	ON_WM_QUERYNEWPALETTE()

	ON_COMMAND(ID_HTMLTEST_CREATEHTMLWINDOW, OnCreateHTMLWindow)
	ON_COMMAND(ID_HTMLTEST_SHOWHTMLWINDOW, OnShowHTMLWindow)
	ON_COMMAND(ID_HTMLTEST_GOHOME, OnGoHome)
	ON_UPDATE_COMMAND_UI(ID_HTMLTEST_GOHOME, OnUpdateGoHome)
	ON_COMMAND(ID_HTMLTEST_GOPREVIOUS, OnGoPrevious)
	ON_UPDATE_COMMAND_UI(ID_HTMLTEST_GOPREVIOUS, OnUpdateGoPrevious)
	ON_COMMAND(ID_HTMLTEST_GONEXT, OnGoNext)
	ON_UPDATE_COMMAND_UI(ID_HTMLTEST_GONEXT, OnUpdateGoNext)
	ON_COMMAND(ID_HTMLTEST_RELOAD, OnReload)
	ON_COMMAND(ID_HTMLTEST_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(ID_HTMLTEST_STOP, OnUpdateStop)
	ON_COMMAND(ID_HTMLTEST_GOTOSITE, OnGotoSite)
	ON_UPDATE_COMMAND_UI(ID_HTMLTEST_GOTOSITE, OnUpdateGotoSite)
	ON_COMMAND(ID_HTMLTEST_GETCURRENTADDRESS, OnGetCurrentAddress)
	ON_COMMAND(ID_HTMLTEST_GETCURRENTTITLE, OnGetCurrentTitle)
	ON_COMMAND(ID_HTMLTEST_READINITFILE, OnReadInitFile)
	ON_COMMAND(ID_HTMLTEST_SETCACHEDIR, OnSetCacheDir)
	ON_COMMAND(ID_HTMLTEST_GETCACHEDIR, OnGetCacheDir)
	ON_COMMAND(ID_HTMLTEST_EMPTYCACHEDIR, OnEmptyCache)
	ON_COMMAND(ID_HTMLTEST_PRINT, OnPrintHTMLDocument)
	ON_COMMAND(ID_OPTIONS_INTERNET, OnInternetEnable)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_INTERNET, OnUpdateInternetEnable)
	ON_COMMAND(ID_HTMLTEST_FORMSUBMITEVENT, OnFormSubmitEvent)
	ON_UPDATE_COMMAND_UI(ID_HTMLTEST_FORMSUBMITEVENT, OnUpdateFormSubmitEvent)
	ON_COMMAND(ID_TOOLS_XFRSTATUSEVENT, OnXfrStatusEvent)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_XFRSTATUSEVENT, OnUpdateXfrStatusEvent)
	ON_COMMAND(ID_TOOLS_MOUSEMOVEEVENT, OnMouseMoveEvent)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_MOUSEMOVEEVENT, OnUpdateMouseMoveEvent)
	//ON_COMMAND(ID_TOOLS_TRANSFERSTARTENDEVENT, OnXfrStartEndEvent)
	//ON_UPDATE_COMMAND_UI(ID_TOOLS_TRANSFERSTARTENDEVENT, OnUpdateXfrStartEndEvent)
	ON_COMMAND(ID_HELP_CONTENTS, OnISDKHelp)

	ON_MESSAGE(WM_USER + 10, OnEventHandle) 
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_HTMLTEST_CREATEHTMLWINDOW,
	ID_HTMLTEST_GOTOSITE,
	ID_HTMLTEST_RELOAD,
		ID_SEPARATOR,
	ID_HTMLTEST_GOHOME,
	ID_HTMLTEST_GOPREVIOUS,
	ID_HTMLTEST_GONEXT,
		ID_SEPARATOR,
	ID_HTMLTEST_PRINT,
		ID_SEPARATOR,
	ID_HTMLTEST_STOP,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
//	ID_INDICATOR_CAPS,
//	ID_INDICATOR_NUM,
//	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here 
	RegisterHTMLDll("Talent", "9999", 
       "X*tAume60");
	m_bFormSubmitEvent = FALSE;
	m_bXfrStatusEvent = FALSE;
	m_bXfrStartEndEvent = 0;
	m_bMouseMoveEvent = FALSE;
	m_bInternetEnable = TRUE;  
	m_htmlWnd = NULL;
}

CMainFrame::~CMainFrame()
{
}

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd)
{
	if (m_htmlWnd)
		::SendMessage(m_htmlWnd, WM_PALETTECHANGED, (WPARAM)(pFocusWnd->GetSafeHwnd()), 0L);   
	return; 
}  

BOOL CMainFrame::OnQueryNewPalette()
{
	if (m_htmlWnd)
		::SendMessage(m_htmlWnd, WM_QUERYNEWPALETTE, 0, 0L);   
	return TRUE;
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CHtmlFrame::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	SIZE buttonSize;
	buttonSize.cx = 38;
	buttonSize.cy = 38;
	SIZE imageSize;
	imageSize.cx = 32;
	imageSize.cy = 31;
	m_wndToolBar.SetSizes(buttonSize, imageSize);

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;      // fail to create
	}
    
	m_bShowTitleBar = TRUE;
	m_bShowTransferStatus = TRUE;
	m_bFormSubmitEvent = FALSE;  
	
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// test HTML functionalities:
void CMainFrame::OnCreateHTMLWindow()
{
    static char BASED_CODE szFilter[] = "HTML Files (*.htm) | *.htm | All Files (*.*) | *.* ||";
    char default_fname[128];
    strcpy(default_fname, "isdk.htm");
	CFileDialog dlg(TRUE, NULL, default_fname, OFN_READONLY, szFilter, NULL );
	if (dlg.DoModal() == IDOK)
	{
		CString MyFileName = dlg.GetPathName();
		char *myfile;
		myfile = MyFileName.GetBuffer(128);
		ISDK_CreationStruct opt = {0, 0, 400, 400, 1, 2};
		m_htmlWnd = LoadHTMLFile(AfxGetInstanceHandle(), 
	                	m_hWndMDIClient, 
	                    myfile, &opt);
	    MyFileName.ReleaseBuffer;
	}
}


void CMainFrame::OnShowHTMLWindow()
{ 
	MoveHTMLWinToFront();
}


void CMainFrame::OnGoHome()
{
	GoHome();
}

void CMainFrame::OnUpdateGoHome(CCmdUI *pCmdUI)
{
    int			history_index;
    int			history_total;
	history_index = GetNavigateIndex();
	history_total = GetNavigateTotal();
	pCmdUI->Enable(history_total > 1 && history_index > 0);
}


void CMainFrame::OnGoPrevious()
{
	GoPrevious();
}

void CMainFrame::OnUpdateGoPrevious(CCmdUI *pCmdUI)
{
    int			history_index;
    int			history_total;
	history_index = GetNavigateIndex();
	history_total = GetNavigateTotal();
	pCmdUI->Enable(history_total > 1 && history_index > 0);
}


void CMainFrame::OnGoNext()
{
	GoNext();
}

void CMainFrame::OnUpdateGoNext(CCmdUI *pCmdUI)
{
    int			history_index;
    int			history_total;
	history_index = GetNavigateIndex();
	history_total = GetNavigateTotal();
	pCmdUI->Enable(history_index < history_total - 1);
}


void CMainFrame::OnReload()
{
	Reload();
}


void CMainFrame::OnStop()
{
#ifdef SLIPPP
	StopHTTPDownload();
#endif
}

void CMainFrame::OnUpdateStop(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_bInternetEnable);
}


void CMainFrame::OnGotoSite()
{
	CRmtOpenDlg dlg;
	dlg.DoModal();
}

void CMainFrame::OnUpdateGotoSite(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_bInternetEnable);
}


void CMainFrame::OnGetCurrentAddress()
{
	char *currAddr = GetCurrHTMLAddr();
	if (currAddr && currAddr[0])
	{
		char txt[300];
		sprintf(txt, "Current HTML address is: %s", currAddr);
		AfxMessageBox(txt);
	}               
	else               
		AfxMessageBox("Current HTML address is empty."); 
}


void CMainFrame::OnGetCurrentTitle()
{
	char *currTitle = GetCurrHTMLTitle();
	if (currTitle && currTitle[0])
	{
		char txt[300];
		sprintf(txt, "Current HTML document title is: %s", currTitle);
		AfxMessageBox(txt); 
	}
	else               
		AfxMessageBox("Current HTML document title is empty."); 
}


void CMainFrame::OnFormSubmitEvent()
{ 
	m_bFormSubmitEvent = m_bFormSubmitEvent ? FALSE : TRUE; 
	if (m_bFormSubmitEvent)
		HTMLRegisterForEvents(GetSafeHwnd(), ID_FORMSUBMIT);
	else
		HTMLRegisterForEvents(NULL, ID_FORMSUBMIT);
}


void CMainFrame::OnUpdateFormSubmitEvent(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFormSubmitEvent);
}


void CMainFrame::OnXfrStatusEvent()
{
#ifdef SLIPPPP 
	m_bXfrStatusEvent = m_bXfrStatusEvent ? FALSE : TRUE; 
	if (m_bXfrStatusEvent)
		HTMLRegisterForEvents(GetSafeHwnd(), ID_XFRSTATUS);
	else
		HTMLRegisterForEvents(NULL, ID_XFRSTATUS);
#endif
}

void CMainFrame::OnUpdateXfrStatusEvent(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bXfrStatusEvent);
}

void CMainFrame::OnMouseMoveEvent()
{ 
	m_bMouseMoveEvent = m_bMouseMoveEvent ? FALSE : TRUE; 
	if (m_bMouseMoveEvent)
		HTMLRegisterForEvents(GetSafeHwnd(), ID_MOUSEMOVE);
	else
		HTMLRegisterForEvents(NULL, ID_MOUSEMOVE);
}

void CMainFrame::OnUpdateMouseMoveEvent(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bMouseMoveEvent);
}


void CMainFrame::OnReadInitFile()
{ 
	ReadInitFile("isdk.ini");
	Reload();
}


void CMainFrame::OnSetCacheDir()
{
#ifdef SLIPPPP
	SetCacheDir("cache");   
#endif
}


void CMainFrame::OnGetCacheDir()
{
#ifdef SLIPPPP
	char *currDir = GetCacheDir();
	if (currDir && currDir[0])
	{
		char txt[300];
		sprintf(txt, "Current HTML address is: %s", currDir);
		AfxMessageBox(txt);
	}               
	else               
		AfxMessageBox("Current HTML address is empty."); 
#endif
}


void CMainFrame::OnEmptyCache()
{
#ifdef SLIPPPP 
	EmptyCache();
#endif
}


void CMainFrame::OnPrintHTMLDocument()
{ 
	PrintHTMLDoc();
}


void CMainFrame::OnUpdateInternetEnable(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bInternetEnable);
}


void CMainFrame::OnInternetEnable()
{ 
#ifdef SLIPPPP
	m_bInternetEnable = m_bInternetEnable ? FALSE : TRUE; 
	SetWinsock(m_bInternetEnable);
#endif
}


void CMainFrame::OnISDKHelp()
{ 
	ISDK_CreationStruct opt = {0, 0, 400, 400, 1, 2};
	
	m_htmlWnd = LoadHTMLFile(AfxGetInstanceHandle(), 
	                 m_hWndMDIClient, 
	                 "isdk.htm", 
	                 &opt);
}


LONG CMainFrame::OnEventHandle(WPARAM id, LPARAM lparam)
{
	char *formInfo;
	char tmp[300];
	
	switch (id)
	{
	case ID_FORMSUBMIT:
		if (!lparam)
			return 0L;
		formInfo = (char *)lparam;
		AfxMessageBox(formInfo); 
		free(formInfo);
		return 1L; 
#ifdef SLIPPPP
	case ID_XFRSTATUS:
		if (!lparam)
			return 0L;
		strcpy(tmp, (char *)lparam);
        m_wndStatusBar.SetWindowText(tmp);
        m_wndStatusBar.UpdateWindow();
		return 1L;  
#endif
	case ID_MOUSEMOVE:
		if (!lparam)
		{
			tmp[0] = '\0';
         	m_wndStatusBar.SetWindowText(tmp);
         	m_wndStatusBar.UpdateWindow();
		}
		else
		{
			strcpy(tmp, (char *)lparam);
         	m_wndStatusBar.SetWindowText(tmp);
         	m_wndStatusBar.UpdateWindow();
		}
		return 1L;
	
#ifdef SLIPPPP
	case ID_XFRSTARTEND:
		if (!lparam)
		{
			return 0L;
		}
		else
		{
			m_bXfrStartEndEvent = (int)lparam;
			if (m_bXfrStartEndEvent > 3)
			{
				m_bXfrStartEndEvent = 0;
			}
		}
		return 1L;
#endif 
	} 
	return 0L;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CHtmlFrame::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CHtmlFrame::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
