#ifndef HTMLDLL_H 
#define HTMLDLL_H

typedef struct ISDK_CreationStruct
{
	int x;		// window horizontal position. use CW_USEDEFAULT (0x8000) for default horizontal positon.
	int y;		// window vertical position. use CW_USEDEFAULT (0x8000) for default vertical position.
	int cx;		// window width. use CW_USEDEFAULT (0x8000) for default width.
	int cy;		// window height. use CW_USEDEFAULT (0x8000) for default height.
	BOOL caption;	// whether we want caption or not. TRUE or FALSE.
	int mdichild;	// whether we want the html window to be a MDI child window or not.
} ISDK_CreationStruct;

#define ID_FORMSUBMIT 0
#define ID_WINDOWCLOSE 1
#define ID_MOUSEMOVE  2
#define ID_LEFTBUTTONDOWN  3

#ifdef SLIPPPP
#define ID_XFRSTATUS  4
#define ID_XFRSTARTEND  5
//just for XFR start end event message
#define TRANSFER_START 1
#define TRANSFER_IMAGESTART 2
#define TRANSFER_TEXTDONE 3
#define TRANSFER_FAILED 4
#define TRANSFER_ABORTED 5
#define TRANSFER_IMAGEDONE 6
#define TRANSFER_IMAGEFAILED 7
#define TRANSFER_IMAGEABORTED 8
#endif // SLIPPPP

// flag masks for LoadBuffer:
#define IVIEW_LB_FINISH  0x01   // finish loading all buffers?
#define IVIEW_LB_SHOW    0x02   // whether show the incomplete buffer or not  

#ifdef __cplusplus
extern "C" {
#endif
#ifdef WIN32

_declspec(dllexport) BOOL FAR PASCAL RegisterHTMLDll(LPSTR user_name,
                                          LPSTR user_count,
                                          LPSTR license_code);
                                                   
_declspec(dllexport) HWND FAR PASCAL LoadHTMLFile(HINSTANCE hInst, 
                                         HWND hParent, 
                                         char *filename,
                                         ISDK_CreationStruct *option);

_declspec(dllexport) BOOL FAR PASCAL MoveHTMLWinToFront();

// flag masks for LoadBuffer:
#define IVIEW_LB_FINISH  		0x01   // finish loading all buffers?
#define IVIEW_LB_SHOW    		0x02   // whether show the incomplete buffer or not
#define IVIEW_LB_LINE_PERCENT 	0x04   // set scroll percentage by line  

// Special
_declspec(dllexport) HWND FAR PASCAL LoadBuffer(char *homeDir, char *buffer, int flag, int scroll_pos);
_declspec(dllexport) BOOL FAR PASCAL SetScrollPercent(int scroll_percent);  

// Navigate
_declspec(dllexport) BOOL FAR PASCAL GoHome();
_declspec(dllexport) BOOL FAR PASCAL GoPrevious();
_declspec(dllexport) BOOL FAR PASCAL GoNext();
_declspec(dllexport) BOOL FAR PASCAL Reload();  
_declspec(dllexport) BOOL FAR PASCAL StopHTTPDownload();  
_declspec(dllexport) BOOL FAR PASCAL HTTPGetFile(char *http_addr, char *local_fname);
_declspec(dllexport) BOOL FAR PASCAL HTTPPostFile(char *http_addr, char *local_fname, char *post_data);
_declspec(dllexport) BOOL FAR PASCAL OpenRemote(char *http_addr);

// General
_declspec(dllexport) char * FAR PASCAL GetCurrHTMLAddr();
_declspec(dllexport) char * FAR PASCAL GetCurrHTMLTitle();
_declspec(dllexport) int FAR PASCAL GetNavigateIndex();
_declspec(dllexport) int FAR PASCAL GetNavigateTotal();
_declspec(dllexport) BOOL FAR PASCAL SetUpdateTitleBar(BOOL onoff);
_declspec(dllexport) BOOL FAR PASCAL ReadInitFile(char *InitFileName);  
_declspec(dllexport) BOOL FAR PASCAL SaveSettingsToFile(char *InitFileName);

// Winsock related:
_declspec(dllexport) BOOL FAR PASCAL SetWinsock(BOOL onoff);

// return:
//         1 -- sucessful
//        -1 -- cache directory is empty
//        -2 -- cache directory does not exist
_declspec(dllexport) int FAR PASCAL SetCacheDir(char *my_dir);
  
_declspec(dllexport) char * FAR PASCAL GetCacheDir();
_declspec(dllexport) void FAR PASCAL EmptyCache();

// Printing
_declspec(dllexport) void FAR PASCAL PrintHTMLDoc(); 

// register events from i-sdk
_declspec(dllexport) BOOL FAR PASCAL HTMLRegisterForEvents(HWND hwnd, UINT id);

_declspec(dllexport) BOOL FAR PASCAL SetDebug(BOOL onoff);
#else

BOOL FAR PASCAL _export RegisterHTMLDll(LPSTR user_name,
                                          LPSTR user_count,
                                          LPSTR license_code);
                                                   
HWND FAR PASCAL _export LoadHTMLFile(HINSTANCE hInst, 
                                         HWND hParent, 
                                         char *filename,
                                         ISDK_CreationStruct *option);

BOOL FAR PASCAL _export MoveHTMLWinToFront();

// flag masks for LoadBuffer:
#define IVIEW_LB_FINISH  		0x01   // finish loading all buffers?
#define IVIEW_LB_SHOW    		0x02   // whether show the incomplete buffer or not
#define IVIEW_LB_LINE_PERCENT 	0x04   // set scroll percentage by line  

// Special
HWND FAR PASCAL _export LoadBuffer(char *homeDir, char *buffer, int flag, int scroll_pos);
BOOL FAR PASCAL _export SetScrollPercent(int scroll_percent);  

// Navigate
BOOL FAR PASCAL _export GoHome();
BOOL FAR PASCAL _export GoPrevious();
BOOL FAR PASCAL _export GoNext();
BOOL FAR PASCAL _export Reload();  
BOOL FAR PASCAL _export StopHTTPDownload();  
BOOL FAR PASCAL _export HTTPGetFile(char *http_addr, char *local_fname);
BOOL FAR PASCAL _export HTTPPostFile(char *http_addr, char *local_fname, char *post_data);
BOOL FAR PASCAL _export OpenRemote(char *http_addr);

// General
char * FAR PASCAL _export GetCurrHTMLAddr();
char * FAR PASCAL _export GetCurrHTMLTitle();
int FAR PASCAL _export GetNavigateIndex();
int FAR PASCAL _export GetNavigateTotal();
BOOL FAR PASCAL _export SetUpdateTitleBar(BOOL onoff);
BOOL FAR PASCAL _export ReadInitFile(char *InitFileName);  
BOOL FAR PASCAL _export SaveSettingsToFile(char *InitFileName);

// Winsock related:
BOOL FAR PASCAL _export SetWinsock(BOOL onoff);

// return:
//         1 -- sucessful
//        -1 -- cache directory is empty
//        -2 -- cache directory does not exist
int FAR PASCAL _export SetCacheDir(char *my_dir);
  
char * FAR PASCAL _export GetCacheDir();
void FAR PASCAL _export EmptyCache();

// Printing
void FAR PASCAL _export PrintHTMLDoc(); 

// register events from i-sdk
BOOL FAR PASCAL _export HTMLRegisterForEvents(HWND hwnd, UINT id);

BOOL FAR PASCAL _export SetDebug(BOOL onoff);
#endif //WIN32
#ifdef __cplusplus
}
#endif

#endif // HTMLDLL_H
